package com.tmax.openframe.file;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.dataobject.exception.EmptyResultException;
import com.tmax.proobject.dataobject.session.SessionContainer;
import java.math.*;
import java.sql.SQLException;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OFCB001_FD_OUT_NEW_CUSTOMERS {
    private Long currentSeqId = null;
    private static final int DEFAULT_FETCH_SIZE = 100;
    private OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof dof;
    private @Getter FileStatus fileStatus;
    private Iterator<OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Do> forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS;

    public OFCB001_FD_OUT_NEW_CUSTOMERS() {
        dof = new OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof();
        forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS = null;
    }

    public void start(Long key) {
        currentSeqId = key;
        dof.setSeq_Id(currentSeqId);
        dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.READ_GE);
        forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS = dof.getForwardList()
                .iterator();
        if (forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS.hasNext()) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return;
        }
        fileStatus = FileStatus.NORMAL;
    }

    public OFCB001_OUT_REC read() {
        if (fileStatus == FileStatus.AT_END_CONDITION_SEQUENCED) {
            fileStatus = FileStatus.ALREADY_AT_END_CONDITION;
            return null;
        }
        OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Do tmp = null;
        if (forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS != null) {
            if (forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS.hasNext()) {
                tmp = forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS.next();
                currentSeqId = tmp.getSeq_Id();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        } else {
            dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.READ_GE);
            dof.setSeq_Id(getNextSeqId());
            forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS = dof
                    .getForwardList().iterator();
            if (forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS.hasNext()) {
                tmp = forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS.next();
                currentSeqId = tmp.getSeq_Id();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        }
        fileStatus = FileStatus.NORMAL;
        return OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_DoToOFCB001_OUT_RECMapper.INSTANCE
                .toOFCB001_OUT_REC(tmp);
    }

    public OFCB001_OUT_REC readNext() {
        return read();
    }

    public OFCB001_OUT_REC readKey(Long key) {
        currentSeqId = key;
        dof.setSeq_Id(currentSeqId);
        dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.READ_EQ);
        forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS = dof.getForwardList()
                .iterator();
        OFCB001_OUT_REC record = read();
        if (record == null) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return null;
        }
        return record;
    }

    public void rewrite(OFCB001_OUT_REC data, Long seq) {
        OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Do tmpObject = OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_DoToOFCB001_OUT_RECMapper.INSTANCE
                .toOFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Do(data);
        dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.REWRITE);
        tmpObject.setSeq_Id(seq);
        try {
            dof.update(tmpObject);
            fileStatus = FileStatus.NORMAL;
        } catch (EmptyResultException ex) {
            fileStatus = FileStatus.INVALID_KEY_CREATE;
        }
    }

    public void rewrite(OFCB001_OUT_REC data) {
        rewrite(data, currentSeqId);
    }

    public void write(OFCB001_OUT_REC data) {
        dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.WRITE);
        dof.add(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_DoToOFCB001_OUT_RECMapper.INSTANCE
                .toOFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Do(data));
        fileStatus = FileStatus.NORMAL;
    }

    public int delete() {
        return _delete(currentSeqId);
    }

    public int delete(Long key) {
        int cnt = _delete(key);
        if (cnt == 0) {
            fileStatus = FileStatus.INVALID_KEY_READ;
        } else {
            fileStatus = FileStatus.NORMAL;
        }
    }

    private int _delete(Long key) {
        if (dof == null
                || forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS == null) {
            return 0;
        }
        dof.setFullQuery(OFCB001_OFCB001_FD_OUT_NEW_CUSTOMERS_Dof.FULLQUERY.DELETE);
        dof.setSeq_Id(currentSeqId);
        return dof.remove();
    }

    public void close() {
        SessionContainer.getInstance().commit();
        forwardListIterator_OFCB001_FD_OUT_NEW_CUSTOMERS = null;
        currentSeqId = null;
    }

    private Long getNextSeqId() {
        if (currentSeqId != null) {
            currentSeqId++;
        } else {
            currentSeqId = 1L;
        }
        return currentSeqId;
    }
}
